# CKEditor Changelog

### CKEditor 3.5.3

New features:

- #4890 : Added the possibility to edit the `rel` attribute for links.
- #7004 : Allow loading plugin translations even if they are not present in the plugin definition.
- #7315 : Firing the `resize` event on dialog window instances is now possible.
- #7259 : Dialog window definition allows to specify initial `width` and `height` values.
- #7131 : List item numbering is now supported on pasting from Microsoft Word.

Fixed issues:

- #1272 : [WebKit] It is now possible to apply styles to collapsed selections in Safari and Chrome.
- #7054 : The tooltips for special characters are now lowercased, making them more readable.
- #7102 : "Replace DIV" sample did not work when double-clicking inside the formatted text.
- #7088 : Loading of plugins failed on new instances of the editor after the Insert Special Character dialog window was used.
- #6215 : Removal of inline styles now also removes overrides.
- #6144 : Rich text drop-down lists have wrong height when toolbar is wrapped.
- #6387 : AutoGrow may cause an error when editor instance is destroyed too quickly after a height change.
- #6901 : Mixed direction content was not properly respected in a shared toolbar setting.
- #4809 : Table-related tags are output in wrong order.
- #7092 : Corrupted toolbar button state for inline style after switching to Source.
- #6921 : Pasted text marked by SCAYT in one language is not re-checked if another spellchecking language is selected in the editor.
- #6614 : Enhancement of the resize handle in RTL.
- #5924 : Flash plugin now recognizes Flash content without an `embed` tag.
- #4475 : Protected source in attributes and inline CSS text is not handled correctly.
- #6984 : [FF] Trailing line breaks are lost in `ENTER_BR`.
- #6987 : [IE] Text selection lost when calling `editor::insertHtml` from a dialog window in some situations.
- #6865 : BiDi mirroring does not work when a text direction change is done through a dialog window.
- #6966 : [IE] Unintended paragraph is created in an empty document in `enterMode` set for `BR` and `DIV`.
- #7084 : SCAYT dialog window is now working properly with more than one editor instance in a page.
- #6662 : [FF] List structure pasting error caused by a regression from FF3.5.x is now fixed.
- #7300 : Link dialog window now loads numeric values correctly.
- #7330 : New list items no longer inherit the `value` attribute from their sibling.
- #7293 : The "Automatic" color button is now presented correctly without focus inside the editor.
- #7018 : [IE] Toolbar drop-down lists did not have a border around them.
- #7073 : Image dialog window no longer allows zero height and width value to be entered.
- #7316 : [FF] Clicking on "Paste" button incorrectly breaks the line at the cursor position.
- #6751 : Inline whitespaces are incorrectly stripped when pasting from Word.
- #6236 : [IE] Fixing malformed nested list structure which was introduced by the Backspace key.
- #6649 : [IE] Selection of the full table sometimes does not work.
- #6946 : HTML parser is now able to fix orphan list items.
- #6861 : Indenting a list item should retain the text direction.
- #6938 : Outdenting a list item should retain the text direction.
- #6849 : Correct Enter key behavior on list item.
- #7113 : [WebKit] Undesired document scroll on click after scrolling.
- #6491 : Undesired Image dialog window dimension lock reset on URL change.
- #7284 : [FF Quirks] Maximize now works correctly.
- #6609 : [IE9] Browser in high contrast mode is not properly detected.
- #7222 : [WebKit] Impossible to apply a single style to a collapsed selection without giving the editor focus.
- #7180 : [IE9] When using Kama skin and RTL layout dialog window buttons were not being displayed correctly.
- #7182 : [IE9] When using Office2003/v2 skin and RTL layout dialog window shadows were corrupted.
- #6913 : Invalid escape sequence (`\b`) was used in the PHP integration.
- #5757 : [IE6] Text was not wrapping in the accessibility instructions dialog window.
- [6604] : `Xml.js` and `Ajax.js` are now available as plugins ('xml' and 'ajax').
- #7304 : Microsoft Word cleanup function is not always invoked when clicking on the "Paste From Word" button.
- #6658 : [IE] Pasting text from Microsoft Word with one or more tabs between list items was failing.
- #7433 : [IE9] `ENTER_BR` at the end of a block breaks due to an IE9 regression.
- #7432 : [WebKit] Unable to create a new list in an empty document.
- #4880 : CKEditor changes tag style inside HTML comment with `cke_protected`.
- #7023 : [IE] JavaScript error when a Selection Field is inserted into a page.
- #7034 : Inserting special characters into styled text.
- #7132 : Paste toolbar buttons are becoming disabled.
- #7138 : The `api.html` sample in Opera does not work as expected.
- #7160 : Cannot paste the form element on top of the page.
- #7171 : Double-clicking an image in non-editable content opens the editing dialog window.
- #7455 : Extra line break is added automatically to the preformatted element.
- #7467 : [Firefox] Extra `br` element is added in a nested list.
- Updated the following language files:
  - #7124 : Czech;
  - #7126 : French;
  - #7140 : Catalan;
  - #7215 : Faroese;
  - #7177 : Finnish;
  - #7163 : Norwegian (no and nb);
  - #7219 : Swedish;
  - #7183 : Afrikaans;
  - Hebrew;
  - Spanish;
  - Polish;
  - German;

### CKEditor 3.5.2

Fixed issues:

- #7168 : [IE9] Destroying an editor instance throws an error.
- #7169 : [IE9] Menu item has incorrect height.
- #7178 : [IE9] Read-only attributes do not work in IE9.
- #7181 : [IE9] Toolbar items are not aligned in v2 and Office2003 skins.
- #7174 : [IE9] Elements path does not load correctly when the editor is switched back from Source to WYSIWYG.

### CKEditor 3.5.1

New features:

- #6107 : It is now possible to remove block styles using Styles and Paragraph Format drop-down lists.
- #5590 : Remove Format command works in collapsed selections.
- #5755 : The `dialog_buttonsOrder` option now works in Internet Explorer.
- #6869 : The `data-cke-nostyle` attribute (which was introduced for escaping the element from been influenced by the style system since 3.5) is deprecated in favor of the new `data-nostyle` attribute.
- Revised sample pages with code examples and clarifications.

Fixed issues:

- #5855 : Updating a link multiple times generates wrong `href` attribute.
- #6166 : Error on Maximize command, when the toolbar button is not shown.
- #6607 : Table cell "merge down" and "merge right" commands work only once.
- #6228 : Merge down does not work, throwing a JavasSript error.
- #6625 : BIDI: Mixed LTR/RTL direction causes incorrect behavior.
- #6881 : IFrame capitalization is now consistent throughout labels.
- #6686 : BIDI: [FF] When we apply explicit language direction to a numbered/bulleted list, the corresponding language direction toolbar icon is not highlighted.
- #6566 : It is now possible to exit a blockquote using `ENTER_BR`.
- #6868 : Partial (invalid) list structure crashes the editor on load.
- #6804 : Buggy behavior when editing the `legend` element inside a `fieldset`.
- #6724 : [IE7] Nested list display bug on empty list item.
- #6715 : List items do not create paragraphs after the list placed in a table cell is removed.
- #6695 : [Webkit] Display bug after the editor is restored from the full screen mode.
- #6661 : [IE] Pre-formatted style does not preserve applied text direction.
- #6655 : Using the editor resize grip causes small visual offsets.
- #6604 : The `div` element should be used as a formatting block in `ENTER_BR`.
- #6249 : BIDI: List item bullets are off viewport with RTL text direction.
- #6610 : BIDI: `ENTER_BR` change direction in one line out of multiple.
- #6872 : [IE] Link target field is not populated properly when no target is set.
- #6880 : Samples: Added a user-friendly message for users on servers without PHP support.
- #6628 : Setting `config.enterMode` from PHP fails.
- #6278 : Comments were moved above the `br` tags.
- #6687 : Empty tag should be removed in inline-style format.
- #6645 : Allow to configure whether " (double quotes) characters should be encoded in the contents.
- #6336 : IE: (double)clicking an `input type="submit"` button submitted the form.
- #6646 : Context menu was not working for text inputs present in the initial content.
- #6641 : Copying and pasting links inside the editor was not working.
- #4208 : The `disableObjectResizing` setting now works in IE.
- #6242 : [IE] Editing existing links with `href` of a relative path mangles containing text.
- #5930 : [IE] Style definitions are no longer lowercased.
- #5361 : Preview window's title should reflect the title tag in full page mode.
- #5522 : [IE] In versions < 8 or compatibility mode, `type="text"` was missing in text fields.
- #6126 : [IE] Avoid problems if there are two buttons named "submit".
- #6791 : [IE7] Editor did not show up when the name of a replaced textarea matched the name of a `meta` tag in the page.
- #5684 : [FF] When `forcePasteAsPlainText` is used, the cursor disappears after paste.
- #6390 : Prevent toolbar dialog window buttons from being clicked twice.
- #6684 : [Webkit] Toolbar buttons are not wrapping correctly when the editor is displayed inside a table.
- #6703 : [IE] editor `focus` event not fired in an instance, when a dialog window closes.
- #6873 : Difficult to drag the resize grip of the spell checker dialog window.
- #6896 : [Webkit] Unable to paste into source area when the editor is maximized.
- #6020 : The state of the Cut, Copy, and Paste toolbar now matches the state of the context menu buttons.
- #5256 : JavaScript error thrown when percent (%) sign is used in image URL.
- #6577 : [FF] Selection error when an element containing the editor instance is hidden.
- #5500 : [IE] `value` attribute of text input dialog window field was missing.
- #6665 : [IE] `name` field of Link dialog window was missing.
- #6639 : Line-breaks inside pasted list item from Microsoft Word break the list structure.
- #6909 : [IE] GIF icons of toolbar button from custom plugins are not diplayed in zoom level 100%.
- #6860 : [FF] Double-clicking the placeholder element in order to open a Placeholder dialog window throws a JavaScript error.
- #6630 : Empty `pre` elements are output differently in various browsers.
- #6568 : Insert table row/column does not work with spanning.
- #6735 : Inaccurate read-only selection detection.
- #6728 : BIDI: Change direction does not work with list nested inside a blockquote.
- #6432 : Inserting a table in place of a fully selected list results in a JavaScript error.
- #6438 : [IE] Performance enhancement when typing inside an element with many child nodes.
- #6970 : [IE] Dialog window shadows were presented inaccurately.
- #6672 : [IE] Unnecessary `br` element is no longer inserted after a form.
- #7087 : [FF] Sometimes it was not possible to move cursor out of link at the end of block.
- Updated the following language files:
  - #6981 : English (GB);
  - #6991 : Finnish;
  - #6357 : French;
  - #7055 : Polish;
  - #7068 : German;

### CKEditor 3.5

New features:

- #4090 : Full Adobe AIR support.
- #5084 : Dialog windows are now resizable with a grip located in the footer.
- #5755 : Introduced the dialog_buttonsOrder setting, making it possible to control the buttons order.
- #4648 : Added the new iFrame plugin.
- #6010 : The Automatic option of the font/background color panel now represents the real color.
- #5654 : New "placeholder" plugin.
- #6334 : CKEditor now uses HTML5's data-* attributes for its internal attributes.
- #6103 : It's now possible to control the styling of inline read-only elements with the disableReadonlyStyling setting. It's also possible to avoid inline-styling any element by setting its "data-cke-nostyle" attribute to "1".
- #5404 : fillEmptyBlocks configuration option of v2 is now available.
- #5367 : New CKEDITOR.editor#insertText method (check api.html sample page for usages) is now provided to insert plain text into editor.
- #5915 : New removeDialogTabs configuration option to hide certain dialog tabs.

Fixed issues:

- #4821 : Icons in the toolbar were distorted with IE and zoom != 100%.
- #5587 : Visual improvements in dialogs, reinforce field label on separate line.
- #4652 : Now it's able to disable editor context menu by simply removing the "contextmenu" plugin.
- #5599 : Labels of "specialchar" dialog are now translated.
- #6419 : [IE] List creation by merging problem.
- #6502 : Removed IE6 image preloading, which was used to defect the duplicate request of background images.
- #6822 : Added labels to fake objects.
- #6898 : [IE6] Toolbar icons becomes invisible in RTL.
- Updated the following language files:
  - Hebrew

### CKEditor 3.4.3

Fixed issues:

- #6554 : [Webkit] cannot type after inserting Page Break.
- #6569 : Indentation now complies with text direction of the only item.
- #6579 : The jQuery adapter was not working properly and was turned on in incompatible environments.
- #6644 : Restrict `onmousedown` handler to the toolbar area.
- #6656 : Panelbutton's buttons became active when clicking on Source.
- #6248 : Whitespaces (`nbsp` elements) were incorrectly added into empty table cells and list items.
- #6575 : Tabs disappearing in Link dialog window after a specific sequence of actions.
- #6510 : Margin mirroring does not respect style configuration.
- #6471 : BIDI: Pressing Decrease Indent in an RTL bulleted list causes incorrect behaviour.
- #6479 : BIDI: Language direction is not being preserved when pressing Enter after a Paragraph Format was applied.
- #6670 : BIDI: Indent & List icons are not reversed when we apply RTL direction to a paragraph with any of Paragraph Formatting options.
- #6640 : Floating panels are now being closed when switching modes.
- #4790 : Remove list with multiple items in `enterBr` doesnot preserve line breaks.
- #6297 : Floated inline elements are not taking part in behavior of blocks anymore.
- #6171 : [Firefox] Opening rich content drop-down list scrolls host page to the top when editor has a vertical scrollbar.
- #6330 : List markers from MS Word with Roman numbering are not preserved.
- #6720 : Attribute protection might detect wrong elements.
- #6580 : [IE9] Flash dialog window does not get filled up.
- #6447 : Decreasing indentation of a list with `indentClasses` config does not work.
- #5894 : Adding custom buttons at the bottom of a dialog window does not cause it to expand to include its contents.
- #6513 : Wrong ARIA attributes created on list options of Styles drop-down list.
- #6150 : [Safari] Color dialog window was broken.
- #6747 : Full screen layout issue caused by page element focus outside editor.
- #6779 : Clicking the `body` element on elements path turns the selection on and off immediately.
- #6781 : [IE7] Dialog windows are broken with RTL, Office 2003 and v2 skins.
- #6798 : [IE7] Dialog window buttons disappearing in RTL after dragging.
- #6806 : [IE7] Dialog window buttons invisible on focus.
- #6588 : Copy and paste adds `<span>` if SCAYT is enabled.
- #6673 : IE Target combo for Image Link shown as blank even when we select `<not set>` as an option.
- Updated the following language files:
  - #6756 : Hungarian;
  - #6794 : Japanese;

### CKEditor 3.4.2

New features:

- #5024 : Added a sample that shows how to output HTML that is valid for Flash.

Fixed issues:

- #5237 : English text in dialogs' title was flipped when using RTL language (office2003 and v2 skins).
- #6289 : Deleting nested table removed the parent cell.
- #6341 : The editor contents now have the text cursor.
- #6153 : Chrome: tab focus is wrong.
- #6261 : Focus and infinite loop between multiple editors.
- #6170 : Dedicated class names are removed from floating panels when opening another panel.
- #6339 : Autogrow plugin now doesn't work on maximized editors.
- #6237 : BIDI: Applying same language direction to all paragraphs not working.
- #6353 : [IE] Resize was broken with office2003 and v2 skins.
- #6375 : Avoiding errors when hiding the editor after the blur event.
- #6133 : Styled paragraphs result on buggy list creation.
- #5074 : Link target is not removed when changing to popup.
- #6408 : [IE] Autogrow now works correctly on Quirks.
- #6420 : [IE] The table properties dialog now correctly retrieves the caption text.
- #6141 : It was impossible to outdent a list when indentOffset was set to 0.
- #6377 : FF width and height are not shown for smiley in Image properties dialog.
- #5399 : Lists pasted from Word do not maintain their nesting.
- #6225 : [FF] Cannot transform several lines to list with enterMode BR.
- #6467 : [FF] It is now possible to disable the plugin command on "mode" event.
- #6461 : Attributes are now being kept when changing block formatting.
- #6226 : BIDI: Language direction applied to a Paragraph is removed when we apply one of Paragraph formatting options.
- #5395 : [Opera] Native context menu incorrectly opened after Opera 10.2.
- #6444 : [Opera] Close panels and dialogs don't return focus to wysiwyg frame.
- #6332 : IE: V2 skin bottom dialog's border broken.
- #5646 : Parser incorrectly removes inline element when there's only one comment node enclosed.
- #6189 : Minor code size reduction.
- #5045 : uiColor behaved wrong if multiple editors were used with period in their names.
- #5766 : Config entry "ignoreEmptyParagraph" should only remove one single empty paragraph in document.
- #5931 : Unable to apply inline style because of nested elements with same style name.
- #6083 : Dialog close sometimes cause collapsed editor selection before the insertion.
- #6253 : BIDI: creating a Numbered/Bulleted list causing improper behavior on bidi.
- #4023 : [Opera] Maximize plugin.
- #6403 : [Opera] Font name options are not correctly marked in dropdown list.
- #4534 : [Opera] Arrow key to navigate through combo list has side effects of window scrolling.
- #6534 : [Opera] Menu key brings up both CKEditor and browser context menu.
- #6416 : [IE9] Unable to make text selection with mouse in source area.
- #6417 : [IE9] Context menu opens at the upper-left corner always.
- #6501 : [IE9] Context menu item layout is broken.
- #6099 : BIDI: when we apply explicit language direction to Numbered/Bulleted List the corresponding BIDI Tool bar icon is not highlighted in the Toolbar.
- #6100 : BIDI: when we change Table language direction indentation of text in Table cells is not applied correctly.
- #6376 : BIDI: buttons should not toggle the base language direction.
- #6235 : BIDI: Applying direction to multi-paragraph selection within a div.
- #6187 : [IE6] Multi-instance loading produces 404s on background images.
- #5446 : Setting config.filebrowserImageBrowseUrl results in displaying also Browser Server on links.
- #5626 : CKeditor 3.2.1 : html content attached makes ckeditor crash the browser FF/IE.
- #6508 : BiDi: Margin mirroring logic doesn't honor CSS direction.
- #6043 : BIDI: When we apply RTL direction to a right aligned Paragraph, Paragraph is not moved to the left & Alignment of Paragraph is not changed.
- #6485 : BIDI: When direction is applied on partial selected list, the style is been incorrectly applied to the entire list.
- #6087 : Cursor of input fields in dialog isn't visible in RTL.
- #5595 : Extra leading spaces added in preformatted block.
- #6094 : Match full word option doesn't stop on block boundaries.
- #5730 : [Safari] Continual pastes (holding paste key) breaks document contents.
- #5850 : [IE] Inline style misbehaviors at the beginning of numbered/bulleted list.
- Updated the following language files:
  - #6427 : Ukrainian;
  - #6464 : Finnish;
  - Hebrew;

### CKEditor 3.4.1

New features:

- #5308 : Introduced the filebrowserWindowFeatures setting, making it possible to have custom window features in the file browser window.

Fixed issues:

- #6027 : Modifying Table Properties by selecting more than one cell caused issues.
- #6146 : IE: Floating panels were being opened in the wrong place in RTL pages with horizontal scrollbars.
- #6055 : The timestamp is now added only once to each loaded file.
- #6097 : The bookmarks now use the right name.
- #5717 : Removed the scayt_contextMenuOntop setting and the SCAYT context menu options are always on top.
- #5956 : [FF] It was impossible to create an editor inside an hidden container.
- #5753 : It was impossible to have a default value for the name field in the select dialog.
- #6041 : BIDI: Direction of Increase Indent & Decrease Indent icons are not reversed after changing Lang direction to RTL.
- #6138 : List indentation is not working.
- #5649 : Image dialog too wide when many styles are set.
- #5715 : Cell color picker dialog returns focus to document.
- #6108 : Fixed div style.
- #5336 : Remove object style.
- #6155 : [[FF]] Modifying Table Header Properties by selecting first Row, causing several issues.
- #6163 : Focus not going to Tabs in Image dialog when we went to Edit the Image.
- #6177 : IE we can't start Numbered/Bulleted list on a Empty page.
- #5413 : Browser error after pasting html table in CKEditor.
- #6034 : Horizontal Alignment applied to Table cell is not updated correctly in the Toolbar.
- #6112 : BIDI: Alignment set to text in Table cell is not shown in the Tool bar when we press Enter to start a new Paragraph.
- #6117 : BIDI: Language direction is changing when we come out of Numbered/Bulleted list.
- #6182 : Language Direction field on the Advanced tab of Table Properties dialog has a fixed pixel width.
- #5487 : Fullpage writer problem with line-break.
- #6197 : The CKEDITOR.loader base path auto-detection was not working with the _source folder.
- #6240 : Font Names & Font Sizes should be shown Left Align even for RTL Languages.
- #5975 : Page-break should have proper Alt Text instead of Unknown object. so that JAWS reads it properly.
- #6255 : Inserting a page break as the first node triggered an error.
- #6188 : [IE7] Automatic color button had the wrong cursor.
- #6129 : The show blocks' labels are now shown in the right for RTL languages.
- #5421 : &shy; entity not converted when config.entities=false.
- #5769 : xhtml code generation problem &nbsp; instead of &#160; (htmlentities, entities,entities_additional,..., configuration).
- #4472 : [FF3] Browser window scrolls to loaded CKEditor.
- #6230 : Fixed invalid parameter count for setTimeout function call.
- #5335 : Several lines' formatted data will be merged to one line when we apply Numbers/Bullets.
- #5353 : wrong width of editor after resize() called in Firefox 3.6.
- #5778 : [IE] Unwanted scroll on first mouse right-click.
- #5218 : [FF] Copy/paste of an image from same domain changed URL to relative URL.
- #6265 : Popup window properties were visible in the link dialog's target tab when nothing was selected.
- #6075 : [FF] Newly created links didn't fill in information on edit.
- #6183 : The toolbar panels options sometimes had the contents' link color.
- #6192 : [WebKit] Inserting smileys was not working because of editor focus issues.
- #6178 : [WebKit] Inserting elements by code was failing if the editor didn't receive the focus first.
- #6179 : [WebKit] The Image dialog was not working if the editor didn't receive the focus first.
- #4657 : [Opera] Styles where not working with collapsed selections.
- #5839 : "Insert row after" was removing the ids of the elements from the clicked row.
- #6315 : DIV plugin TT #2885 regression.
- Updated the following language files:
  - #6246 : Chinese Simplified;
  - #6256 : Dutch;
  - #6271 : English;

### CKEditor 3.4

Fixed issues:

- #6118 : Initial focus is now set to the tabs in the table properties dialog.
- #6135 : The dialogadvtab plugin now uses the correct label.
- #6125 : Focus was lost after applying commands in Opera.
- #6137 : The table dialog was missing the default width value on second opening.

### CKEditor 3.4 Beta

New features:

- #5909 : New BiDi feature, making it possible to switch the base language direction of block elements.
- #5268 : Introducing the "tableresize" plugin, which makes it possible to resize tables columns by mouse drag. It's not enabled by default, so it must be enabled in the configurations file.
- #979 : New enableTabKeyTools configuration to allow using the TAB key to navigate through table cells.
- #4606 : Introduce the "autogrow" plugin, which makes the editor resize automatically, based on the contents size.
- #5737 : Added support for the HTML5 contenteditable attribute, making it possible to define read only regions into the editor contents.
- #5418 : New "Advanced" tab introduced on the Table Properties dialog. It's based on the new dialogadvtab plugin.
- #6082 : Introduced the useComputedState setting, making it possible to control whether toolbar features, like alignment and direction, should reflect the "computed" selection states, even when the effective feature value is not applied.

Fixed issues:

- #5911 : BiDi: List items should support and retain correct base language direction
- #5689 : Make it possible to run CKEditor inside of Firefox chrome.
- #6042 : It wasn't possible to align a paragraph with the dir attribute to the opposite direction.
- #6058 : Fixed a small style glitch with file upload fields in IE+Quirks.

### CKEditor 3.3.2

New features:

- #5882 : Introduce the dialog#selectPage event, replicating the OnDialogTabChange feature available in FCKeditor 2.
- #5927 : The native controls in ui.dialog.elements can be styled with the controlStyle definition.

Fixed issues:

- #1644 : Removed references to cursor:hand in the stylesheets.
- #5411 : Anchor, hidden fields and Page-Break objects can no longer be resized.
- #5456 : Initial focus incorect in api_dialog sample page.
- #5628 : Incorrect <pre> siblings merging.
- #5829 : Adding validation for start number field in list style dialog.
- #5845 : Context menu on empty list item loses selection.
- #5860 : [IE] > in attribute values are incorrectly escaped.
- #5905 : SCAYT is not any more enabled by default.
- #5736 : Improved the text generated for mailto: links if no text was selected.
- #4779 : Adjust resize_minWidth and resize_minHeight if smaller than actual dimensions.
- #5687 : Navigation through colors is now compatible with RTL.
- #4615 : [IE] Text fields are no longer disrupted in dialog with RTL.
- #5887 : The number of columns in the smileys table is now configurable via the smiley_columns setting.
- #5100 : It was possible to drag&drop some elements like context menu items or dropdown entries.
- #5933 : Text color and background color panels don't have scrollbars anymore under office2003 and v2 skins.
- #5943 : An error is no longer generated when using percent or pixel values in the image dialog.
- #5951 : Avoid problems with security systems due to the usage of UniversalXPConnect.
- #5441 : Avoid errors if the editor instance is removed from the DOM before calling its destroy() method.
- #4997 : Provide better access to the native input in the ui.dialog.file element.
- #5914 : Modified the Smileys dialog to make active only the images and not their borders.
- #5565 : The scrollbar does not behaves erratically when opening a rich combo in RTL page.
- #5843 : In CKEditor 3.3: When we set the focus in the 'instanceReady' event, FF3.6 is giving js error.
- #5902 : paste and pastetext dialogs cannot be skinned easily.
- #5959 : Dialog auto focus does not check for hidden tabs.
- #5415 : Undo not working when we change the Table Properties for the table on a saved page.
- #5435 : IE: we can't start Numbered/Bulleted list in Tables by Clicking on Insert/Remove Numbers/Bullets Icon.
- #5832 : The JQuery adapter sample is not working properly with SSL.
- #5728 : Text field & Upload Button in Upload Tab of Image Properties dialog are not shown Properly in Arabic.
- #5436 : IE: Cursor goes to next Table Cell after we insert a Smiley in the Table Cell.
- #5580 : Maximize does not work properly in the Office 2003 and V2 skins.
- #5495 : The link dialog was breaking the undo system on some situations.
- #5775 : Required field's label to contain a CSS class to allow it to be styled differently.
- #5999 : Table dialog rows and columns fields are now marked as required.
- #5693 : baseHref detection in the flash dialog now works correctly.
- #5690 : Table cell's width attribute is now respected properly.
- #5819 : Introducing the new removeFormatCleanup event and making sure remove format doesn't break the showborder plugin.
- #5558 : After pasting on WebKit based browsers the editor now scrolls to the end of the pasted content.
- #5799 : Correct plugin dependencies for the liststyle plugin with contextMenu and dialog.
- #5436 : IE: The cursor was moving to the wrong position when inserting inline elements at the end of cells on tables.
- #5984 : Firefox: CTRL+HOME was creating an unwanted empty paragraph at the start of the document.
- #5634 : IE: It was needed to click twice in the editor to make it editable on some situations.
- #5338 : Pasting from Open Office could lead on error.
- #5224 : Some invalid markup could break the editor.
- #5455 : It was not possible to remove formatting from pasted content on specific cases.
- #5735 : IE: The editor was having focus issues when the previous selection got hidden by scroll operations.
- #5563 : Firefox: The disableObjectResizing and disableNativeTableHandles settings stopped working.
- #5781 : Firefox: Editing was not possible in an empty document.
- #5293 : Firefox: Unwanted BR tags were being left in the editor output when it should be empty.
- #5280 : IE: Scrollbars where reacting improperly when clicking in the bar space.
- #5840 : Some dialog access keys are conflicting with "Ctrl + A", select all text behavior on text input.
- #6059 : Changing list type didn't preserve the list's attributes.
- #5193 : In Firefox, the element path options had the text cursor instead of the arrow.
- #6073 : The list context menu was showing the wrong option when in a mixed list hierarchy.
- #6074 : The Insert Table Column command was duplicating the selected column cells ids.
- #6066 : The toolbar combos had the text cursor instead of the arrow.
- #6062 : The toolbar buttons had the text cursor instead of the arrow.
- #6068 : [IE7] A few labels were hidden in a RTL language.
- #6000 : Safari and Chrome where scrolling the contents to the top when moving the focus to the editor.
- #6090 : IE: Textarea with selection inside causes Link dialog issues.
- #5079 : Page break in lists move to above the list when you switch from WYSIWYG to HTML mode and back.
- Updated the following language files:
  - Chinese Simplified;
  - Hebrew;
  - #5962 : German;
  - #5645 : Portuguese;
  - #5797 : Turkish;

### CKEditor 3.3.1

Fixed issues:

- #5780 : Text selection lost when opening some of the dialogs.
- #5787 : Liststyle plugin wasn't packaged into the core (CKEDITOR.resourceManager.load exception).
- #5637 : Fix wrong nesting that generated "<head> must be a child of <html>" warning in Webkit.
- #5790 : Internal only attributes output on fullpage <html> tag.
- #5761 : [IE] Color dialog matrix buttons are barely clickable in quirks mode.
- #5759 : [IE] Clicking on the scrollbar and then on the host page causes error.
- #5772 : List style dialog is missing tab page ids.
- #5782 : [FF] Wysiwyg mode is broken by 'display' style changes on editor's parent DOM tree.
- #5801 : [IE] contentEditable="false" doesn't apply in effect on inline-elements.
- #5794 : Empty find matching twice results in JavaScript error.
- #5732 : If it isn't possible to connect to the SCAYT servers the dialogs might hang in Firefox. Fix for Firefox>=3.6.
- #5807 : [FF2] New page command results in uneditable document.
- #5807 : [FF2] SCAYT plugin is disabled in Firefox2 due to selection interference.
- #5772 : [IE] Some numbered list style types are not supported by IE6/7 and causes JavaScript error.

### CKEditor 3.3

New features:

- #635 : The properties dialog will now open when double clicking on objects.
- #3893 : It's now possible to indent/outdent lists when selecting the first list item.
- #4968 : The contentsLangDirection setting now has a default value 'ui' which inherit language direction from the editor UI language.
- #4649 : The color picker dialog is now accessible.
- #3593 : The editing area is now enabled by contentEditable="true" instead of designMode="on" to allow creating uneditable content elements in all browsers.
- #4056 : Hidden fields will now be displayed as fake element just like in FCKeditor 2.

### CKEditor 3.2.2

New features:

- The SCAYT spell checker is now enabled by default through the autoStartup setting.
- #5631 : The SCAYT context menu options can now be reorganized through the scayt_contextMenuItemsOrder setting.
- #4231 : Introducing the resize_dir setting, to be able to restrict manual resizing of the editor to only one direction (horizontal/vertical).
- #5479 : Introducing the classic ASP integration files and samples.
- #5024 : Added samples (HTML and XHTML) to show how to output HTML using fonts and other attributes instead of styles.
- #4358 : Introduced the List Properties dialog.
- #5485 : Adding the contentsLanguage configuration option to be able to set the language for the editor contents.

Fixed issues:

- #5330 : Corrected detection of CTRL and META keys in Macs for the context menu.
- #5434 : Fixed access denied issues with IE when accessing web sites through IPv6 IP addresses.
- #4476 : [IE] Inaccessible empty list item contains sub list.
- #4881 : [IE] Selection range broken because of cutting a single control type element from it.
- #5505 : Image dialog throw JavaScript error when click close dialog before preview area is loading.
- #5144 : [Chrome] Paste in Webkit sometimes leaves extra 'div' element.
- #5021 : [Firefox] Typing in empty document start from second line when enterMode = CKEDITOR.ENTER_BR.
- #5416 : [IE] Delete table throws a error when enterMode = CKEDITOR.ENTER_BR.
- #4459 : [IE] Select element is penetrating the maximized editor in IE6.
- #5559 : [IE] The first call to setData is affected by iframe cache when loading the wysiwyg mode.
- #5567 : [IE] Remove inline styles in some case doesn't join identical siblings.
- #5450 : [FireFox] Press ENTER on 'replace' button result wrong.
- #5121 : Recognizes the <br /> tag as a separator when apply block styles and enterMode = CKEDITOR.ENTER_BR.
- #5575 : CKEDITOR.replaceAll should consider all kind of white spaces between class names.
- #5582 : Prevent the default behavior when click the 'x' button to close dialog box.
- #5584 : ENTER key with forceEnterMode turns on doesn't inherit current block attributes.
- #4797 : [Opera] Press ENTER key in dialog fields to close throws JavaScript error.
- #5578 : Add flash fake element align property when switch mode (source to wysiwyg).
- #5577 : Update delete column behavior when choose multiple cells in the same column.
- #5512 : Open context menu with SHIFT+F10 doesn't get correct editor selection.
- #5433 : English protocol text directions in Link dialog are not incorrect in 'rtl' UI languages.
- #5553 : Paste dialog clipboard area text direction is incorrect for 'rtl' content languages.
- #4734 : Font size resets when font name is changed in an empty numbered list.
- #5237 : English text in dialogs' title is flipped when using RTL language.
- #3257 : Create list doesn't keep blocks as headings.
- #5111 : [Firefox] JAWS doesn't respect PC cursor mode (application role) on toolbar.
- #5530 : Page break for printing can't be removed with undo.
- #5381 : Unable to place cursor between two paragraphs in body.
- #5568 : [IE6/7] Selecting a entire table cell changes the original range.
- #5623 : [Firefox] Apply style that edges another inline style result incorrect.
- #5586 : [Firefox] Maximize the second editor ruins full screen mode.
- #5617 : HTML filter system does not allow two 'text' filter rules.
- #5663 : General memory clean up after destroying last instance.
- #5461 : [IE] Fix Paste from Word dialog doesn't accept imput problem.
- #5676 : Make color buttons use RRGGBB instead of RGB for better compatibility with IE.
- #4948 : [Safari] Select the first/last cell of table to open context menu may lead to undetected table.
- #5591 : [Firefox] Select a list item makes selected element broken.
- #5667 : Pasting in a RTL page content causes shows up the horizontal scrollbar.
- #5688 : Duplicate ids are used in dialog definition.
- #5719 : [IE] 'change' dialog event should not be triggered when dialog is already closed.
- #5747 : [IE] Error thrown when IE input field editing mode is turned on.
- #5516 : IE8: Toolbar buttons have higher bottom padding.
- #5402 : SHIFT-ENTER could now be used to exit from preformat block.
- SCAYT plugin related:
  - #4836 : Using SCAYT result in fragile elements when applying inline styles.
  - #5425 : [Opera] Disable SCAYT plugin for Opera browser.
  - #5632 : SCAYT word marker is not visible on text with background-color set.
  - #4125 : Remove Format command incorrectly removes SCAYT word markers.
  - #5671 : SCAYT bootstrap script could be added multiple times unnecessarily.
  - #5573 : SCAYT move cursor position after insert element into marked word text.
  - #5546 : SCAYT interferes with undo/redo commands.
  - #5570 : [IE] First enabling SCAYT blind cursor in editor.
  - #5741 : Enable SCAYT cause error in multiple editor instances.
  - #5744 : Remove editor with SCAYT enabled in source mode throws error.
- Updated the following language files:
  - #5432 : Dutch;
  - #5619 : Finnish;
  - #5515 : Hebrew;
  - #5588 : Turkish;

### CKEditor 3.2.1

New features:

- #4478 : Enable the SelectAll command in source mode.
- #5150 : Allow names in the CKEDITOR.config.colorButton_colors setting.
- #4810 : Adding configuration option for image dialog preview area filling text.
- #536 : Object style now could be applied on any parent element of current selection.
- #5290 : Unified stylesSet loading removing dependencies from the styles combo. Now the configuration entry is named 'config.stylesSet' instead of config.stylesCombo_stylesSet and the default location is under the 'styles' plugin instead of 'stylescombo'.
- #5352 : Allow to define the stylesSet array in the config object for the editor.
- #5302 : Adding config option "forceEnterMode".
- #5216 : Extend CKEDITOR.appendTo to allow a data parameter for the initial value.
- #5024 : Added sample to show how to output XHTML and avoid deprecated tags.

Fixed issues:

- #5152 : Indentation using class attribute doesn't work properly.
- #4682 : It wasn't possible to edit block elements in IE that had styles like width, height or float.
- #4750 : Correcting default order of buttons layout in dialogs on Mac.
- #4932 : Fixed collapse button not clickable on simple toolbar.
- #5228 : Link dialog is automatically changes protocol when URLs that starts with '?'.
- #4877 : Fixed CKEditor displays source code in one long line (IE quirks mode + office2003 skin).
- #5132 : Apply inline style leaks into sibling words which are seperated spaces.
- #3599 : Background color style on sized text displayed as narrow band behind.
- #4661 : Translation missing in link dialog.
- #5240 : Flash alignment property is not presented visually on fake element.
- #4910 : Pasting in IE scrolls document to the end.
- #5041 : Table summary attribute can't be removed with dialog.
- #5124 : All inline styles cannot be applied on empty spaces.
- #3570 : SCAYT marker shouldn't appear inside elements path bar.
- #4553 : Dirty check result incorrect when editor document is empty.
- #4555 : Unreleased memory when editor is created and destroyed.
- #5118 : Arrow keys navigation in RTL languages is incorrect.
- #4721 : Remove attribute 'value' of checkbox in IE.
- #5278 : IE: Add validation to check for bad window names of popup window.
- #5171 : Dialogs contains lists don't have proper voice labels.
- #4791 : Can't place cursor inside a form that end with a checkbox/radio.
- #4479 : StylesCombo doesn't reflect the selection state until it's first opened.
- #4717 : 'Unlink' and 'Outdent' command buttons should be disabled on editor startup.
- #5119 : Disabled command buttons are not being properly styled when focused.
- #5307 : Hide dialog page cause problem when there's two tab pages remain.
- #5343 : Active list item ARIA role is wrongly placed.
- #3599 : Background color style applying to text with font size style has been narrowly rendered.
- #4711 : Line break character inside preformatted text makes it unable to type text at the end of previous line.
- #4829 : [IE] Apply style from combo has wrong result on manually created selection.
- #4830 : Retrieving selected element isn't always right, especially selecting using keyboard (SHIFT+ARROW).
- #5128 : Element attribute inside preformatted text is corrupted when converting to other blocks.
- #5190 : Template list entry shouldn't gain initial focus open templates list dialog opens.
- #5238 : Menu button doesn't display arrow icon in high-contrast mode.
- #3576 : Non-attributed element of the same name with the applied style is incorrectly removed.
- #5221 : Insert table into empty document cause JavaScript error thrown.
- #5242 : Apply 'automatic' color option of text color incorrectly removes background-color style.
- #4719 : IE does not escape attribute values properly.
- #5170 : Firefox does not insert text into styled element properly.
- #4026 : Office2003 skin has no toolbar button borders in High Contrast in IE7.
- #4348 : There should have exception thrown when 'CKEDITOR_BASEPATH' couldn't be figured out automatically.
- #5364 : Focus may not be put into dialog correctly when dialog skin file is loading slow.
- #4016 : Justify the layout of forms select dialog in Chrome and IE7.
- #5373 : Variable 'pathBlockElements' defines wrong items in CKEDITOR.dom.elementPath.
- #5082 : Ctrl key should be described as Cmd key on Mac.
- #5182 : Context menu is not been announced correctly by ATs.
- #4898 : Can't navigate outside table under the last paragraph of document.
- #4950 : List commands could compromise list item attribute and styles.
- #5018 : Find result highlighting remove normal font color styles unintentionally.
- #5376 : Unable to exit list from within a empty block under list item.
- #5145 : Various SCAYT fixes.
- #5319 : Match whole word doesn't work anymore after replacement has happened.
- #5363 : 'title' attribute now presents on all editor iframes.
- #5374 : Unable to toggle inline style when the selection starts at the linefeed of the previous paragraph.
- #4513 : Selected link element is not always correctly detected when using keyboard arrows to perform such selection.
- #5372 : Newly created sub list should inherit nothing from the original (parent) list, except the list type.
- #5274 : [IE6] Templates preview image is displayed in wrong size.
- #5292 : Preview in font size and family doesn't work with custom styles.
- #5396 : Selection is lost when use cell properties dialog to change cell type to header.
- #4082 : [IE+Quirks] Preview text in the image dialog is not wrapping.
- #4197 : Fixing format combo don't hide when editor blur on Safari.
- #5401 : The context menu break layout with Office2003 and V2 skin on IE quirks mode.
- #4825 : Fixing browser context menu is opened when clicking right mouse button twice.
- #5356 : The SCAYT dialog had issues with Prototype enabled pages.
- #5266 : SCAYT was disturbing the rendering of TH elements.
- #4688 : SCAYT was interfering on checkDirty.
- #5429 : High Contrast mode was being mistakenly detected when loading the editor through Dojo's xhrGet.
- #5221 : Range is mangled when making collapsed selection in an empty paragraph.
- #5261 : Config option 'scayt_autoStartup' slow down editor loading.
- #3846 : Google Chrome - No Img properties after inserting.
- #5465 : ShiftEnter=DIV doesn't respect list item when pressing ENTER at end of list item.
- #5454 : After replaced success, the popup window couldn't be closed and a js error occured.
- #4784 : Incorrect cursor position after delete table cells.
- #5149 : [FF] Cursor disappears after maximize when the editor has focus.
- #5220 : DTD now shows tolerance to <style> appear inside content.
- #5440 : Mobile browsers (iPhone, Android...) are marked as incompatible as they don't support editing features.
- #5504 : [IE6/7] 'Paste' dialog will always get opened even when user allows the clipboard access dialog when using 'Paste' button.
- Updated the following language files:
  - #5326 : Catalan;
  - #5370 : Faroese;
  - #5392 : Finnish;
  - #4580 : Hungarian;
  - #5301 : Norwegian;

### CKEditor 3.2

New features:

- Several accessibility enhancements:
  - #4502 : The editor accessibility is now totally based on WAI-ARIA.
  - #5015 : Adding accessibility help dialog plugin.
  - #5014 : Keyboard navigation compliance with screen reader suggested keys.
  - #4595 : Better accessibility in the Templates dialog.
  - #3389 : Esc/Arrow Key now works for closing sub menu.
- #4973 : The Style field in the Div Container dialog is now loading the styles defined in the default styleset used by the Styles toolbar combo.

Fixed issues:

- #5049 : Form Field list command in JAWS incorrectly lists extra fields.
- #5008 : Lock/Unlock ratio buttons in the Image dialog was poorly designed in High Contrast mode.
- #3980 : All labels in dialogs now use <label> instead of <div>.
- #5213 : Reorganization of some entries in the language files to make it more consistent.
- #5199 : In IE, single row toolbars didn't have the bottom padding.

### CKEditor 3.1.1

New features:

- #4399 : Improved support for external file browsers by allowing executing a callback function.
- #4612 : The text of links is now updated if it matches the URL to which it points to.
- #4936 : New localization support for the Welsh language.

Fixed issues:

- #4272 : Kama skin toolbar was broken in IE+Quirks+RTL.
- #4987 : Changed the url which is called by the Browser Server button in the Link tab of Image Properties dialog.
- #5030 : The CKEDITOR.timestamp wasn't been appended to the skin.js file.
- #4993 : Removed the float style from images when the user selects 'not set' for alignment.
- #4944 : Fixed a bug where nested list structures with inconsequent levels were not being pasted correctly from MS Word.
- #4637 : Table cells' 'nowrap' attribute was not being loaded by the cell property dialog. Thanks to pomu0325.
- #4724 : Using the mouse to insert a link in IE might create incorrect results.
- #4640 : Small optimizations for the fileBrowser plugin.
- #4583 : The "Target Frame Name" field is now visible when target is set to 'frame' only.
- #4863 : Fixing iframedialog's height doesn't stretch to 100% (except IE Quirks).
- #4964 : The BACKSPACE key positioning was not correct in some cases with Firefox.
- #4980 : Setting border, vspace and hspace of images to zero was not working.
- #4773 : The fileBrowser plugin was overwriting onClick functions eventually defined on fileButton elements.
- #4731 : The clipboard plugin was missing a reference to the dialog plugin.
- #5051 : The about plugin was missing a reference to the dialog plugin.
- #5146 : The wsc plugin was missing a reference to the dialog plugin.
- #4632 : The print command will now properly break on the insertion point of page break for printing.
- #4862 : The English (United Kingdom) language file has been renamed to en-gb.js.
- #4618 : Selecting an emoticon or the lock and reset buttons in the image dialog fired the onBeforeUnload event in IE.
- #4678 : It was not possible to set tables' width to empty value.
- #5012 : Fixed dependency issues with the menu plugin.
- #5040 : The editor will not properly ignore font related settings that have extra item separators (semi-colons).
- #4046 : Justify should respect config.enterMode = CKEDITOR.ENTER_BR.
- #4622 : Inserting tables multiple times was corrupting the undo system.
- #4647 : [IE] Selection on an element within positioned container is lost after open context-menu then click one menu item.
- #4683 : Double-quote character in attribute values was not escaped in the editor output.
- #4762 : [IE] Unexpected vertical-scrolling behavior happens whenever focus is moving out of editor in source mode.
- #4772 : Text color was not being applied properly on links.
- #4795 : [IE] Press 'Del' key on horizontal line or table result in error.
- #4824 : [IE] <br/> at the very first table cell breaks the editor selection.
- #4851 : [IE] Delete table rows with context-menu may cause error.
- #4951 : Replacing text with empty string was throwing errors.
- #4963 : Link dialog was not opening properly for e-mail type links.
- #5043 : Removed the possibility of having an unwanted script tag being outputted with the editor contents.
- #3678 : There were issues when editing links inside floating divs with IE.
- #4763 : Pressing ENTER key with text selected was not deleting the text in some situations.
- #5096 : Simple ampersand attribute value doesn't work for more than one occurrence.
- #3494 : Context menu is too narrow in some translations.
- #5005 : Fixed HTML errors in PHP samples.
- #5123 : Fixed broken XHTML in User Interface Languages sample.
- #4893 : Editor now understands table cell inline styles.
- #4611 : Selection around <select> in editor doesn't cause error anymore.
- #4886 : Extra BR tags were being created in the output HTML.
- #4933 : Empty tags with BR were being left in the DOM.
- #5127 : There were errors when removing dialog definition pages through code.
- #4767 : CKEditor was not working when ckeditor_source.js is loaded in the <body> .
- #5062 : Avoided security warning message when loading the wysiwyg area in IE6 under HTTPS.
- #5135 : The TAB key will now behave properly when in Source mode.
- #4988 : It wasn't possible to use forcePasteAsPlainText with Safari on Mac.
- #5095 : Safari on Mac deleted the current selection in the editor when Edit menu was clicked.
- #5140 : In High Contrast mode, arrows were now been displayed for menus with submenus.
- #5163 : The undo system was not working on some specific cases.
- #5162 : The ajax sample was throwing errors when loading data.
- #4999 : The Template dialog was not generating an undo snapshot.
- Updated the following language files:
  - #5006 : Dutch;
  - #5039 : Finnish;
  - #5148 : Hebrew;
  - #5071 : Russian;
  - #5147 : Spanish;

### CKEditor 3.1

New features:

- #4067 : Introduced the full page editing support (from <html> to </html>).
- #4228 : Introduced the Shared Spaces feature.
- #4379 : Introduced the new powerful pasting system and word cleanup procedure, including enhancements to the paste as plain text feature.
- #2872 : Introduced the new native PHP API, the first standardized server side support.
- #4210 : Added CKEditor plugin for jQuery.
- #2885 : Added 'div' dialog and corresponding context menu options.
- #4574 : Added the table merging tools and corresponding context menu options.
- #4340 : Added the email protection option for link dialog.
- #4463 : Added inline CSS support in all places where custom stylesheet could apply.
- #3881 : Added color dialog for 'more color' option in color buttons.
- #4341 : Added the 'showborder' plugin.
- #4549 : Make the anti-cache query string configurable.
- #4708 : Added the 'htmlEncodeOutput' config option.
- #4342 : Introduced the bodyId and bodyClass settings to specify the id and class. to be used in the editing area at runtime.
- #3401 : Introduced the baseHref setting so it's possible to set the URL to be used to resolve absolute and relative URLs in the contents.
- #4729 : Added support to fake elements for comments.

Fixed issues:

- #4707 : Fixed invalid link is requested in image preview.
- #4461 : Fixed toolbar separator line along side combo enlarging the toolbar height.
- #4596 : Fixed image re-size lock buttons aren't accessible in high-contrast mode.
- #4676 : Fixed editing tables using table properties dialog overwrites original style values.
- #4714 : Fixed IE6 JavaScript error when editing flash by commit 'Flash' dialog.
- #3905 : Fixed 'wysiwyg' mode causes unauthenticated content warnings over SSL in FF 3.5.
- #4768 : Fixed open context menu in IE throws js error when focus is not inside document.
- #4822 : Fixed applying 'Headers' to existing table does not work in IE.
- #4855 : Fixed toolbar doesn't wrap well for 'v2' skin in all browsers.
- #4882 : Fixed auto detect paste from MS-Word is not working for Safari.
- #4882 : Fixed unexpected margin style left behind on content cleaning up from MS-Word.
- #4896 : Fixed paste nested list from MS-Word with measurement units set to cm is broken.
- #4899 : Fixed unable to undo pre-formatted style.
- #4900 : Fixed ratio-lock inconsistent between browsers.
- #4901 : Fixed unable to edit any link with popup window's features in Firefox.
- #4904 : Fixed when paste happen from dialog, it always throw JavaScript error.
- #4905 : Fixed paste plain text result incorrect when content from dialog.
- #4889 : Fixed unable to undo 'New Page' command after typing inside editor.
- #4892 : Fixed table alignment style is not properly represented by the wrapping div.
- #4918 : Fixed switching mode when maximized is showing background page contents.

### CKEditor 3.0.2

New features:

- #4343 : Added the configuration option 'browserContextMenuOnCtrl' so it's possible to enable the default browser context menu by holding the CTRL key.

Fixed issues:

- #4552 : Fixed float panel doesn't show up since editor instanced been destroyed once.
- #3918 : Fixed fake object is editable with Image dialog.
- #4053 : Fixed 'Form Properties' missing from context menu when selection collapsed inside form.
- #4401 : Fixed customized by removing 'upload' tab page from 'Link dialog' cause JavaScript error.
- #4477 : Adding missing tag names in object style elements.
- #4567 : Fixed IE throw error when pressing BACKSPACE in source mode.
- #4573 : Fixed 'IgnoreEmptyPargraph' config doesn't work with the config 'entities' is set to 'false'.
- #4614 : Fixed attribute protection fails because of line-break.
- #4546 : Fixed UIColor plugin doesn't work when editor id contains CSS selector preserved keywords.
- #4609 : Fixed flash object is lost when loading data from outside editor.
- #4625 : Fixed editor stays visible in a div with style 'visibility:hidden'.
- #4621 : Fixed clicking below table caused an empty table been generated.
- #3373 : Fixed empty context menu when there's no menu item at all.
- #4473 : Fixed setting rules on the same element tag name throws error.
- #4514 : Fixed press 'Back' button breaks wysiwyg editing mode is Firefox.
- #4542 : Fixed unable to access buttons using tab key in Safari and Opera.
- #4577 : Fixed relative link url is broken after opening 'Link' dialog.
- #4597 : Fixed custom style with same attribute name but different attribute value doesn't work.
- #4651 : Fixed 'Deleted' and 'Inserted' text style is not rendering in wysiwyg mode and is wrong is source mode.
- #4654 : Fixed 'CKEDITOR.config.font_defaultLabel(fontSize_defaultLabel)' is not working.
- #3950 : Fixed table column insertion incorrect when selecting empty cell area.
- #3912 : Fixed UIColor not working in IE when page has more than 30+ editors.
- #4031 : Fixed mouse cursor on toolbar combo has more than 3 shapes.
- #4041 : Fixed open context menu on multiple cells to remove them result in only one removed.
- #4185 : Fixed resize handler effect doesn't affect flash object on output.
- #4196 : Fixed 'Remove Numbered/Bulleted List' on nested list doesn't work well on nested list.
- #4200 : Fixed unable to insert 'password' type filed with attributes.
- #4530 : Fixed context menu couldn't open in Opera.
- #4536 : Fixed keyboard navigation doesn't work at all in IE quirks mode.
- #4584 : Fixed updated link Target field is not updating when updating to certain values.
- #4603 : Fixed unable to disable submenu items in contextmenu.
- #4672 : Fixed unable to redo the insertion of horizontal line.
- #4677 : Fixed 'Tab' key is trapped by hidden dialog elements.
- #4073 : Fixed insert template with replace option could result in empty document.
- #4455 : Fixed unable to start editing when image inside document not loaded.
- #4517 : Fixed 'dialog_backgroundCoverColor' doesn't work on IE6.
- #3165 : Fixed enter key in empty list item before nested one result in collapsed line.
- #4527 : Fixed checkbox generate invalid 'checked' attribute.
- #1659 : Fixed unable to click below content to start editing in IE with 'config.docType' setting to standard compliant.
- #3933 : Fixed extra <br> left at the end of document when the last element is a table.
- #4736 : Fixed PAGE UP and PAGE DOWN keys in standards mode are not working.
- #4725 : Fixed hitting 'enter' before html comment node produces a JavaScript error.
- #4522 : Fixed unable to redo when typing after insert an image with relative url.
- #4594 : Fixed context menu goes off-screen when mouse is at right had side of screen.
- #4673 : Fixed undo not available straight away if shift key is used to enter first character.
- #4690 : Fixed the parsing of nested inline elements.
- #4450 : Fixed selecting multiple table cells before apply justify commands generates spurious paragraph in Firefox.
- #4733 : Fixed dialog opening sometimes hang up Firefox and Safari.
- #4498 : Fixed toolbar collapse button missing tooltip.
- #4738 : Fixed inserting table inside bold/italic/underline generates error on ENTER_BR mode.
- #4246 : Fixed avoid XHTML deprecated attributes for image styling.
- #4543 : Fixed unable to move cursor between table and hr.
- #4764 : Fixed wrong exception message when CKEDITOR.editor.append() to non-existing elements.
- #4521 : Fixed dialog layout in IE6/7 may have scroll-bar and other weird effects.
- #4709 : Fixed inconsistent scroll-bar behavior on IE.
- #4776 : Fixed preview page failed to open when relative URl contains in document.
- #4812 : Fixed 'Esc' key not working on dialogs in Opera.
- Updated the following language files:
  - #4346 : Dutch;
  - #4837 : Finnish;
  - #4371 : Hebrew;
  - #4607 #4713 : Japanese;
  - #4660 : Norwegian.

### CKEditor 3.0.1

New features:

- #4219 : Added fallback mechanism for config.language.
- #4194 : Added support for using multiple css style sheets within the editor.

Fixed issues:

- #3898 : Added validation for URL value in Image dialog.
- #3528 : Fixed Context Menu issue when triggered using Shift+F10.
- #4028 : Maximize control's tool tip was wrong once it is maximized.
- #4237 : Toolbar is chopped off in Safari browser 3.x.
- #4241 : Float panels are left on screen while editor is destroyed.
- #4274 : Double click event is incorrect handled in 'divreplace' sample.
- #4354 : Fixed TAB key on toolbar to not focus disabled buttons.
- #3856 : Fixed focus and blur events in source view mode.
- #3438 : Floating panels are off by (-1px, 0px) in RTL mode.
- #3370 : Refactored use of CKEDITOR.env.isCustomDomain().
- #4230 : HC detection caused js error.
- #3978 : Fixed setStyle float on IE7 strict.
- #4262 : Tab and Shift+Tab was not working to cycle through CTRL+SHIFT+F10 context menu in IE.
- #3633 : Default context menu isn't disabled in toolbar, status bar, panels...
- #3897 : Now there is no image previews when the URL is empty in image dialog.
- #4048 : Context submenu was lacking uiColor.
- #3568 : Dialogs now select all text when tabbing to text inputs.
- #3727 : Cell Properties dialog was missing color selection option.
- #3517 : Fixed "Match cyclic" field in Find & Replace dialog.
- #4368 : borderColor table cell attribute haven't worked for none-IE
- #4203 : In IE quirks mode + toolbar collapsed + source mode editing block height was incorrect.
- #4387 : Fixed: right clicking in Kama skin can lead to a javascript error.
- #4397 : Wysiwyg mode caused the host page scroll.
- #4385 : Fixed editor's auto adjusting on DOM structure were confusing the dirty checking mechanism.
- #4397 : Fixed regression of [3816] where turn on design mode was causing Firefox3 to scroll the host page.
- #4254 : Added basic API sample.
- #4107 : Normalize css font-family style text for correct comparision.
- #3664 : Insert block element in empty editor document should not create new paragraph.
- #4037 : 'id' attribute is missing with Flash dialog advanced page.
- #4047 : Delete selected control type element when 'Backspace' is pressed on it.
- #4191 : Fixed: dialog changes confirmation on image dialog appeared even when no changes have been made.
- #4351 : Dash and dot could appear in attribute names.
- #4355 : 'maximize' and 'showblock' commands shouldn't take editor focus.
- #4504 : Fixed 'Enter'/'Esc' key is not working on dialog button.
- #4245 : 'Strange Template' now come with a style attribute for width.
- #4512 : Fixed styles plugin incorrectly adding semicolons to style text.
- #3855 : Fixed loading unminified _source files when ckeditor_source.js is used.
- #3717 : Dialog settings defaults can now be overridden in-page through the CKEDITOR.config object.
- #4481 : The 'stylesCombo_stylesSet' configuration entry didn't work for full URLs.
- #4480 : Fixed scope attribute in th.
- #4467 : Fixed bug to use custom icon in context menus. Thanks to george.
- #4190 : Fixed select field dialog layout in Safari.
- #4518 : Fixed unable to open dialog without editor focus in IE.
- #4519 : Fixed maximize without editor focus throw error in IE.
- Updated the following language files:
  - #3947 : Arabic;
  - #4466 : Czech;
  - #4363 : Danish;
  - #4346 : Dutch;
  - #4371 #4456 : Hebrew;
  - #4382 : Polish.

### CKEditor 3.0

New features:

- #3188 : Introduce <pre> formatting feature when converting from other blocks.
- #4445 : editor::setData now support an optional callback parameter.

Fixed issues:

- #2856 : Fixed problem with inches in Paste From Word plugin.
- #3929 : Using Paste dialog, the text is pasted into current selection
- #3920 : Mouse cursor over characters in Special Character dialog now is correct
- #3882 : Fixed an issue with PasteFromWord dialog in which default values was ignored
- #3859 : Fixed Flash dialog layout in Webkit
- #3852 : Disabled textarea resizing in dialogs
- #3831 : The attempt to remove the contextmenu plugin will not anymore break the editor
- #3781 : Colorbutton is now disabled in 'source' mode
- #3848 : Fixed an issue with Webkit in witch elements in the Image and Link dialogs had wrong dimensions.
- #3808 : Fixed UI Color Picker dialog size in example page.
- #3658 : Editor had horizontal scrollbar in IE6.
- #3819 : The cursor was not visible when applying style to collapsed selections in Firefox 2.
- #3809 : Fixed beam cursor when mouse cursor is over text-only buttons in IE.
- #3815 : Fixed an issue with the form dialog in which the "enctype" attribute is outputted as "encoding".
- #3785 : Fixed an issue in CKEDITOR.tools.htmlEncode() which incorrectly outputs &nbsp; in IE8.
- #3820 : Fixed an issue in bullet list command in which a list created at the bottom of another gets merged to the top.
- #3830 : Table cell properties dialog doesn't apply to all selected cells.
- #3835 : Element path is not refreshed after click on 'newpage'; and safari is not putting focus on document also.
- #3821 : Fixed an issue with JAWS in which toolbar items are read inconsistently between virtual cursor modes.
- #3789 : The "src" attribute was getting duplicated in some situations.
- #3591 : Protecting flash related elements including '<object>', '<embed>' and '<param>'.
- #3759 : Fixed CKEDITOR.dom.element::scrollIntoView logic bug which scroll even element is inside viewport.
- #3773 : Fixed remove list will merge lines.
- #3829 : Fixed remove empty link on output data.
- #3730 : Indent is performing on the whole block instead of selected lines in enterMode = BR.
- #3844 : Fixed UndoManager register keydown on obsoleted document
- #3805 : Enabled SCAYT plugin for IE.
- #3834 : Context menu on table caption was incorrect.
- #3812 : Fixed an issue in which the editor may show up empty or uneditable in IE7, 8 and Firefox 3.
- #3825 : Fixed JS error when opening spellingcheck.
- #3862 : Fixed html parser infinite loop on certain malformed source code.
- #3639 : Button size was inconsistent.
- #3874 : Paste as plain text in Safari loosing lines.
- #3849 : Fixed IE8 crashes when applying lists and indenting.
- #3876 : Changed dialog checkbox and radio labels to explicit labels.
- #3843 : Fixed context submenu position in IE 6 & 7 RTL.
- #3864 : [FF]Document is not editable after inserting element on a fresh page.
- #3883 : Fixed removing inline style logic incorrect on Firefox2.
- #3884 : Empty "href" attribute was duplicated on output data.
- #3858 : Fixed the issue where toolbars break up in IE6 and IE7 after the browser is resized.
- #3868 : [chrome] SCAYT toolbar options was in reversed order.
- #3875 : Fixed an issue in Safari where table row/column/cell menus are not useable when table cells are selected.
- #3896 : The editing area was flashing when switching forth and back to source view.
- #3894 : Fixed an issue where editor failed to initialize when using the on-demand loading way.
- #3903 : Color button plugin doesn't read config entry from editor instance correctly.
- #3801 : Comments at the start of the document was lost in IE.
- #3871 : Unable to redo when undos to the front of snapshots stack.
- #3909 : Move focus from editor into a text input control is broken.
- #3870 : The empty paragraph desappears when hitting ENTER after "New Page".
- #3887 : Fixed an issue in which the create list command may leak outside of a selected table cell and into the rest of document.
- #3916 : Fixed maximize does not enlarge editor width when width is set.
- #3879 : [webkit] Color button panel had incorrect size on first open.
- #3839 : Update Scayt plugin to reflect the latest change from SpellChecker.net.
- #3742 : Fixed wrong dialog layout for dialogs without tab bar in IE RTL mode .
- #3671 : Fixed body fixing should be applied to the real type under fake elements.
- #3836 : Fixed remove list in enterMode=BR will merge sibling text to one line.
- #3949 : Fixed enterKey within pre-formatted text introduce wrong line-break.
- #3878 : Whenever possible, dialogs will not present scrollbars if the content is too big for its standard size.
- #3782 : Remove empty list in table cell result in collapsed cell.
- Updated the following language files:
  - #4183 : Basque;
  - #3837 : Brazilian Portuguese;
  - #4171 : Catalan;
  - #4115 : Chinese (Simplified);
  - #4179 : Chinese (Traditional);
  - #4102 : Croatian;
  - #4105 : French;
  - #4104 : German;
  - #4116 : Italian;
  - #4091 : Japanese;
  - #4120 : Polish;
  - #3987 : Spanish;
  - #4089 : Ukrainian;
  - #4166 : Vietnamese.
- #3984 : [IE]The pre-formatted style is generating error.
- #3946 : Fixed unable to hide contextmenu.
- #3956 : Fixed About dialog in Source Mode for IE.
- #3953 : Fixed keystroke for close Paste dialog.
- #3951 : Reset size and lock ratio options were not accessible in Image dialog.
- #3921 : Fixed Container scroll issue on IE7.
- #3940 : Fixed list operation doesn't stop at table.
- #3891 : [IE] Fixed 'automatic' font color doesn't work.
- #3972 : Fixed unable to remove a single empty list in document in Firefox with enterMode=BR.
- #3973 : Fixed list creation error at the end of document.
- #3959 : Pasting styled text from word result in content lost.
- #3793 : Combined images into sprites.
- #3783 : Fixed indenting command in table cells create collapsed paragraph.
- #3968 : About dialog layout was broken with IE+Standards+RTL.
- #3991 : In IE quirks, text was not visible in v2 and office2003 skins.
- #3983 : In IE, we'll now silently ignore wrong toolbar definition settings which have extra commas being left around.
- Fixed the following test cases:
  - #3992 : core/ckeditor2.html
  - #4138 : core/plugins.html
  - #3801 : plugins/htmldataprocessor/htmldataprocessor.html
- #3989 : Host page horizontal scrolling a lot when on having righ-to-left direction.
- #4001 : Create link around existing image result incorrect.
- #3988 : Destroy editor on form submit event cause error.
- #3994 : Insert horizontal line at end of document cause error.
- #4074 : Indent error with 'indentClasses' config specified.
- #4057 : Fixed anchor is lost after switch between editing modes.
- #3644 : Image dialog was missin radio lock.
- #4014 : Firefox2 had no dialog button backgrounds.
- #4018 : Firefox2 had no richcombo text visible.
- #4035 : [IE6] Paste dialog size was too small.
- #4049 : Kama skin was too wide with config.width.
- The following released files now doesn't require the _source folder
  - #4086 : _samples/ui_languages.html
  - #4093 : _tests/core/dom/document.html
  - #4094 : Smiley plugin file
  - #4097 : No undo/redo support for fontColor and backgroundColor buttons.
- #4085 : Paste and Paste from Word dialogs were not well styled in IE+RTL.
- #3982 : Fixed enterKey on empty list item result in weird dom structure.
- #4101 : Now it is possible to close dialog before gets focus.
- #4075 : [IE6/7]Fixed apply custom inline style with "class" attribute failed.
- #4087 : [Firefox]Fixed extra blocks created on create list when full document selected.
- #4097 : No undo/redo support for fontColor and backgroundColor buttons.
- #4111 : Fixed apply block style after inline style applied on full document error.
- #3622 : Fixed shift enter with selection not deleting highlighted text.
- #4092 : [IE6] Close button was missing for dialog without multiple tabs.
- #4003 : Markup on the image dialog was disrupted when removing the border input.
- #4096 : Editor content area was pushed down in IE RTL quirks.
- #4112 : [FF] Paste dialog had scrollbars in quirks.
- #4118 : Dialog dragging was occasionally behaving strangely .
- #4077 : The toolbar combos were rendering incorrectly in some languages, like Chinese.
- #3622 : The toolbar in the v2 skin was wrapping improperly in some languages.
- #4119 : Unable to edit image link with image dialog.
- #4117 : Fixed dialog error when transforming image into button.
- #4058 : [FF] wysiwyg mode is sometimes not been activated.
- #4114 : [IE] RTE + IE6/IE7 Quirks = dialog mispositoned.
- #4123 : Some dialog buttons were broken in IE7 quirks.
- #4122 : [IE] The image dialog was being rendered improperly when loading an image with long URL.
- #4144 : Fixed the white-spaces at the end of <pre> is incorrectly removed.
- #4143 : Fixed element id is lost when extracting contents from the range.
- #4007 : [IE] Source area overflow from editor chrome.
- #4145 : Fixed the on demand ("basic") loading model of the editor.
- #4139 : Fixed list plugin regression of [3903].
- #4147 : Unify style text normalization logic when comparing styles.
- #4150 : Fixed enlarge list result incorrect at the inner boundary of block.
- #4164 : Now it is possible to paste text in Source mode even if forcePasteAsPlainText = true.
- #4129 : [FF]Unable to remove list with Ctrl-A.
- #4172 : [Safari] The trailing <br> was not been always added to blank lines ending with &nbsp;.
- #4178 : It's now possible to copy and paste Flash content among different editor instances.
- #4193 : Automatic font color produced empty span on Firefox 3.5.
- #4186 : [FF] Fixed First open float panel cause host page scrollbar blinking.
- #4227 : Fixed destroy editor instance created on textarea which is not within form cause error.
- #4240 : Fixed editor name containing hyphen break editor completely.
- #3828 : Malformed nested list is now corrected by the parser.

### CKEditor 3.0 RC

Changelog starts at this release.